HDU 1298 T9【字典树增加||查询】

任意门:http://acm.hdu.edu.cn/showproblem.php?pid=1298

T9

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 3917    Accepted Submission(s): 1415


Problem Description
A while ago it was quite cumbersome to create a message for the Short Message Service (SMS) on a mobile phone. This was because you only have nine keys and the alphabet has more than nine letters, so most characters could only be entered by pressing one key several times. For example, if you wanted to type "hello" you had to press key 4 twice, key 3 twice, key 5 three times, again key 5 three times, and finally key 6 three times. This procedure is very tedious and keeps many people from using the Short Message Service.

This led manufacturers of mobile phones to try and find an easier way to enter text on a mobile phone. The solution they developed is called T9 text input. The "9" in the name means that you can enter almost arbitrary words with just nine keys and without pressing them more than once per character. The idea of the solution is that you simply start typing the keys without repetition, and the software uses a built-in dictionary to look for the "most probable" word matching the input. For example, to enter "hello" you simply press keys 4, 3, 5, 5, and 6 once. Of course, this could also be the input for the word "gdjjm", but since this is no sensible English word, it can safely be ignored. By ruling out all other "improbable" solutions and only taking proper English words into account, this method can speed up writing of short messages considerably. Of course, if the word is not in the dictionary (like a name) then it has to be typed in manually using key repetition again.


Figure 8: The Number-keys of a mobile phone.


More precisely, with every character typed, the phone will show the most probable combination of characters it has found up to that point. Let us assume that the phone knows about the words "idea" and "hello", with "idea" occurring more often. Pressing the keys 4, 3, 5, 5, and 6, one after the other, the phone offers you "i", "id", then switches to "hel", "hell", and finally shows "hello".

Write an implementation of the T9 text input which offers the most probable character combination after every keystroke. The probability of a character combination is defined to be the sum of the probabilities of all words in the dictionary that begin with this character combination. For example, if the dictionary contains three words "hell", "hello", and "hellfire", the probability of the character combination "hell" is the sum of the probabilities of these words. If some combinations have the same probability, your program is to select the first one in alphabetic order. The user should also be able to type the beginning of words. For example, if the word "hello" is in the dictionary, the user can also enter the word "he" by pressing the keys 4 and 3 even if this word is not listed in the dictionary.
 
Input
The first line contains the number of scenarios.

Each scenario begins with a line containing the number w of distinct words in the dictionary (0<=w<=1000). These words are given in the next w lines. (They are not guaranteed in ascending alphabetic order, although it's a dictionary.) Every line starts with the word which is a sequence of lowercase letters from the alphabet without whitespace, followed by a space and an integer p, 1<=p<=100, representing the probability of that word. No word will contain more than 100 letters.

Following the dictionary, there is a line containing a single integer m. Next follow m lines, each consisting of a sequence of at most 100 decimal digits 2-9, followed by a single 1 meaning "next word".
 
Output
The output for each scenario begins with a line containing "Scenario #i:", where i is the number of the scenario starting at 1.

For every number sequence s of the scenario, print one line for every keystroke stored in s, except for the 1 at the end. In this line, print the most probable word prefix defined by the probabilities in the dictionary and the T9 selection rules explained above. Whenever none of the words in the dictionary match the given number sequence, print "MANUALLY" instead of a prefix.

Terminate the output for every number sequence with a blank line, and print an additional blank line at the end of every scenario.
 
Sample Input
2 5 hell 3 hello 4 idea 8 next 8 super 3 2 435561 43321 7 another 5 contest 6 follow 3 give 13 integer 6 new 14 program 4 5 77647261 6391 4681 26684371 77771
 
Sample Output
Scenario #1: i id hel hell hello i id ide idea Scenario #2: p pr pro prog progr progra program n ne new g in int c co con cont anoth anothe another p pr MANUALLY MANUALLY
 
Source

题意概括:

输入 N 个单词,每个单词有特定的频率。然后有 M 次访问,每次都是模拟九键电话,电话数字上有特定的字符,每次输入一串数字,联想到频率最高的单词前缀或者单词。

解题思路:

把单词存进字典树,然后暴力数字串所有可能构成的字符串,在这些字符串的基础下去匹配字典树里可能达到的最大频率,最后更新得出最大频率的前缀或者单词。

AC code:

  1 #include <bits/stdc++.h>
  2 #define INF 0x3f3f3f3f
  3 #define LL long long int
  4 #define Bits 27
  5 using namespace std;
  6 
  7 const int MAXN = 110;
  8 char str[MAXN], str_now[MAXN], str_ans[MAXN];
  9 int node_cnt, N, M, ans_val;
 10 struct Trie
 11 {
 12     Trie *next[Bits];
 13     int v;
 14     inline void it(const int value){
 15         this->v = value;
 16         for(int index = 0; index < Bits; index++)
 17             this->next[index] = NULL;
 18     }
 19 };
 20 Trie *Root;
 21 
 22 char mmp[10][4]{
 23     {'#', '#', '#', '#'},
 24     {'#', '#', '#', '#'},
 25     {'a', 'b', 'c', '#'},
 26     {'d', 'e', 'f', '#'},
 27     {'g', 'h', 'i', '#'},
 28     {'j', 'k', 'l', '#'},
 29     {'m', 'n', 'o', '#'},
 30     {'p', 'q', 'r', 's'},
 31     {'t', 'u', 'v', '#'},
 32     {'w', 'x', 'y', 'z'},
 33 };
 34 void Create_Trie(char *str, int val)
 35 {
 36     int len_str = strlen(str);
 37     Trie *p = Root, *temp;
 38     for(int i = 0; i < len_str; i++){
 39         int index = str[i]-'a';
 40         if(p->next[index] == NULL){
 41             temp = (Trie *)malloc(sizeof(Trie));
 42             temp->it(val);
 43             p->next[index] = temp;
 44         }
 45         else (p->next[index]->v)+=val;
 46         p = p->next[index];
 47     }
 48 }
 49 inline void Deal_Trie(Trie *tp)
 50 {
 51     if(tp == NULL) return;
 52     for(int i = 0; i < Bits; i++)
 53     {
 54         if(tp->next[i] == NULL) continue;
 55         Deal_Trie(tp->next[i]);
 56     }
 57     free(tp);return;
 58 }
 59 void slv(int now, int len, Trie *node)
 60 {
 61     if(now == len){
 62         if(node->v > ans_val){
 63             strcpy(str_ans, str_now);
 64             ans_val = node->v;
 65         }return;
 66     }
 67     int index = str[now]-'0';
 68     for(int i = 0; i < 4; i++){
 69         if(mmp[index][i] == '#')break;
 70         int id = mmp[index][i]-'a';
 71         if(node->next[id]){
 72             str_now[now] = mmp[index][i];
 73             str_now[now+1] = '';
 74             slv(now+1, len, node->next[id]);
 75         }
 76     }
 77 }
 78 int main()
 79 {
 80     int T_case, tpval;
 81     scanf("%d", &T_case);
 82     for(int ca = 1; ca <= T_case; ca++){
 83         scanf("%d", &N);
 84         Root = (Trie *)malloc(sizeof(Trie));
 85         Root->it(0);
 86         for(int i = 1; i <= N; i++){
 87             scanf("%s %d", str, &tpval);
 88             Create_Trie(str, tpval);
 89         }
 90         printf("Scenario #%d:
", ca);
 91         scanf("%d", &M);
 92         while(M--){
 93             scanf("%s", str);
 94             int len = strlen(str);
 95             for(int s = 1; s < len; s++){
 96                 ans_val = -INF;
 97                 slv(0, s, Root);
 98                 if(ans_val > -INF) puts(str_ans);
 99                 else puts("MANUALLY");
100             }
101             puts("");
102         }
103         puts("");Deal_Trie(Root);
104     }
105     return 0;
106 }
View Code
原文地址:https://www.cnblogs.com/ymzjj/p/9547535.html